Index: sansmodels/src/sans/models/c_extensions/gaussian.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/gaussian.h	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
+++ sansmodels/src/sans/models/c_extensions/gaussian.h	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
@@ -0,0 +1,31 @@
+#if !defined(gaussian_h)
+#define gaussian_h
+
+/** Structure definition for Gaussian parameters.
+ * The Gaussian is normalized to the 'scale' parameter.
+ *  
+ * f(x)=scale * 1/(sigma^2*2pi)e^(-(x-mu)^2/2sigma^2)
+ * 
+ * [PYTHONCLASS] = Gaussian
+ * [DESCRIPTION] = <text>f(x)=scale * 1/(sigma^2*2pi)e^(-(x-mu)^2/2sigma^2)</text>
+ */
+typedef struct {
+    /// Scale factor 
+    //  [DEFAULT]=scale=1.0
+    double scale;
+    /// Standard deviation
+    //  [DEFAULT]=sigma=1 
+    double sigma;
+    /// Center of the Gaussian distribution
+    //  [DEFAULT]=center=0.0 
+    double center;
+} GaussianParameters;
+
+/// 1D scattering function
+double gaussian_analytical_1D(GaussianParameters *pars, double x);
+
+/// 2D scattering function
+double gaussian_analytical_2D(GaussianParameters *pars, double x, double phi);
+double gaussian_analytical_2DXY(GaussianParameters *pars, double x, double y);
+
+#endif
Index: sansmodels/src/sans/models/c_extensions/logNormal.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/logNormal.c	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
+++ sansmodels/src/sans/models/c_extensions/logNormal.c	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
@@ -0,0 +1,58 @@
+/**
+ * log normal function
+ */
+
+#include "logNormal.h"
+#include <math.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+
+/**
+ * Function to evaluate 1D Log normal function.
+ * The function is normalized to the 'scale' parameter.
+ * 
+ * f(x)=scale * 1/(sigma*math.sqrt(2pi))e^(-1/2*((math.log(x)-mu)/sigma)^2)
+ * 
+ * @param pars: parameters of the log normal 
+ * @param x: x-value
+ * @return: function value
+ */
+double logNormal_analytical_1D(LogNormalParameters *pars, double x) {
+	double sigma2 = pow(pars->sigma, 2);	
+	return pars->scale / (x*sigma2) * exp( -pow((log(x) -pars->center), 2) / (2*sigma2));
+}
+
+/**
+ * Function to evaluate 2D log normal  function
+ * The function is normalized to the 'scale' parameter.
+ * 
+ * f(x,y) = LogNormal(x) * Lognormal(y)
+ * 
+ * where both Gaussians share the same parameters.
+ * 
+ * @param pars: parameters of the log normal 
+ * @param x: x-value
+ * @param y: y-value
+ * @return: function value
+ */
+double logNormal_analytical_2DXY(LogNormalParameters *pars, double x, double y) {
+    return logNormal_analytical_1D(pars, x) * logNormal_analytical_1D(pars, y);
+} 
+
+/**
+ * Function to evaluate 2D log normal  function
+ * The function is normalized to the 'scale' parameter.
+ * 
+ * f(x,y) = Lognormal(x) * Lognormal(y)
+ * 
+ * where both log normal s share the same parameters.
+ * 
+ * @param pars: parameters of the log normal
+ * @param length: length of the (x,y) vector
+ * @param phi: angle relative to x
+ * @return: function value
+ */
+double logNormal_analytical_2D(LogNormalParameters *pars, double length, double phi) {
+    return logNormal_analytical_2DXY(pars, length*cos(phi), length*sin(phi));
+} 
Index: sansmodels/src/sans/models/c_extensions/logNormal.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/logNormal.h	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
+++ sansmodels/src/sans/models/c_extensions/logNormal.h	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
@@ -0,0 +1,31 @@
+#if !defined(logNormal_h)
+#define logNormal_h
+
+/** Structure definition for Gaussian parameters.
+ * The Log normal is normalized to the 'scale' parameter.
+ *  
+ * f(x)=scale * 1/(sigma*math.sqrt(2pi))e^(-1/2*((math.log(x)-mu)/sigma)^2)
+ *
+ * [PYTHONCLASS] = LogNormal
+ * [DESCRIPTION] = <text>f(x)=scale * 1/(sigma*math.sqrt(2pi))e^(-1/2*((math.log(x)-mu)/sigma)^2)</text>
+ */
+typedef struct {
+    /// Scale factor 
+    //  [DEFAULT]=scale=1.0
+    double scale;
+    /// Standard deviation
+    //  [DEFAULT]=sigma=1 
+    double sigma;
+    /// Center of the Log Normal distribution
+    //  [DEFAULT]=center=0.0 
+    double center;
+} LogNormalParameters;
+
+/// 1D scattering function
+double logNormal_analytical_1D(LogNormalParameters *pars, double x);
+
+/// 2D scattering function
+double logNormal_analytical_2D(LogNormalParameters *pars, double x, double phi);
+double logNormal_analytical_2DXY(LogNormalParameters *pars, double x, double y);
+
+#endif
Index: sansmodels/src/sans/models/c_extensions/lorentzian.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/lorentzian.c	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
+++ sansmodels/src/sans/models/c_extensions/lorentzian.c	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
@@ -0,0 +1,59 @@
+/**
+ * Lorentzian function
+ */
+
+#include "lorentzian.h"
+#include <math.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+
+/**
+ * Function to evaluate 1D Lorentzian function.
+ * The function is normalized to the 'scale' parameter.
+ * 
+ * f(x)=scale * 1/pi 0.5gamma / [ (x-x_0)^2 + (0.5gamma)^2 ]
+ * 
+ * @param pars: parameters of the Lorentzian
+ * @param x: x-value
+ * @return: function value
+ */
+double lorentzian_analytical_1D(LorentzianParameters *pars, double x) {
+	double delta2 = pow( (x-pars->center), 2);
+	return pars->scale / acos(-1.0) * 0.5*pars->gamma /
+		(delta2 + 0.25*pars->gamma*pars->gamma);
+}
+
+/**
+ * Function to evaluate 2D Lorentzian  function
+ * The function is normalized to the 'scale' parameter.
+ * 
+ * f(x,y) = Lorentzian(x) * Lorentzian(y)
+ * 
+ * where both Lorentzians share the same parameters.
+ * 
+ * @param pars: parameters of the Lorentzian
+ * @param x: x-value
+ * @param y: y-value
+ * @return: function value
+ */
+double lorentzian_analytical_2DXY(LorentzianParameters *pars, double x, double y) {
+    return lorentzian_analytical_1D(pars, x) * lorentzian_analytical_1D(pars, y);
+} 
+
+/**
+ * Function to evaluate 2D Lorentzian  function
+ * The function is normalized to the 'scale' parameter.
+ * 
+ * f(x,y) = Lorentzian(x) * Lorentzian(y)
+ * 
+ * where both Lorentzians share the same parameters.
+ * 
+ * @param pars: parameters of the Lorentzian
+ * @param length: length of the (x,y) vector
+ * @param phi: angle relative to x
+ * @return: function value
+ */
+double lorentzian_analytical_2D(LorentzianParameters *pars, double length, double phi) {
+    return lorentzian_analytical_2DXY(pars, length*cos(phi), length*sin(phi));
+} 
Index: sansmodels/src/sans/models/c_extensions/lorentzian.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/lorentzian.h	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
+++ sansmodels/src/sans/models/c_extensions/lorentzian.h	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
@@ -0,0 +1,31 @@
+#if !defined(lorentzian_h)
+#define lorentzian_h
+
+/** Structure definition for Lorentzian parameters.
+ * The Lorentzian is normalized to the 'scale' parameter.
+ *  
+ * f(x)=scale * 1/pi 0.5gamma / [ (x-x_0)^2 + (0.5gamma)^2 ]
+ * 
+ * [PYTHONCLASS] = Lorentzian
+ * [DESCRIPTION] = <text>f(x)=scale * 1/pi 0.5gamma / [ (x-x_0)^2 + (0.5gamma)^2 ]</text>
+ */
+typedef struct {
+    /// Scale factor 
+    //  [DEFAULT]=scale=1.0
+    double scale;
+    /// Width
+    //  [DEFAULT]=gamma=1.0
+    double gamma;
+    /// Center of the Lorentzian distribution
+    //  [DEFAULT]=center=0.0 
+    double center;
+} LorentzianParameters;
+
+/// 1D lorentzian function
+double lorentzian_analytical_1D(LorentzianParameters *pars, double x);
+
+/// 2D lorentzian function
+double lorentzian_analytical_2D(LorentzianParameters *pars, double x, double phi);
+double lorentzian_analytical_2DXY(LorentzianParameters *pars, double x, double y);
+
+#endif
Index: sansmodels/src/sans/models/c_extensions/schulz.c
===================================================================
--- sansmodels/src/sans/models/c_extensions/schulz.c	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
+++ sansmodels/src/sans/models/c_extensions/schulz.c	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
@@ -0,0 +1,65 @@
+/**
+ * Schulz function
+ */
+
+#include "schulz.h"
+#include <math.h>
+#include <stdio.h>
+#include <stdlib.h>
+
+
+/**
+ * Function to evaluate 1D Schulz function.
+ * The function is normalized to the 'scale' parameter.
+ *
+ * f(x)=scale * math.pow(z+1, z+1)*math.pow((R), z)*
+ *					math.exp(-R*(z+1))/(center*gamma(z+1)
+ *		z= math.pow[(1/(sigma/center),2]-1
+ *		R= x/center
+ * @param pars: parameters of the schulz
+ * @param x: x-value
+ * @return: function value
+ */
+double schulz_analytical_1D(SchulzParameters *pars, double x) {
+	double z = pow(pars->center/ pars->sigma, 2)-1;
+	double R= x/pars->center;
+	double zz= z+1;
+	double expo;
+	expo = log(pars->scale)+zz*log(zz)+z*log(R)-R*zz-log(pars->center)-lgamma(zz);
+
+	return exp(expo);//pars->scale * pow(zz,zz) * pow(R,z) * exp(-1*R*zz)/((pars->center) * tgamma(zz)) ;
+}
+
+/**
+ * Function to evaluate 2D schulz function
+ * The function is normalized to the 'scale' parameter.
+ *
+ * f(x,y) = Schulz(x) * Schulz(y)
+ *
+ * where both Shulzs share the same parameters.
+ *
+ * @param pars: parameters of the schulz
+ * @param x: x-value
+ * @param y: y-value
+ * @return: function value
+ */
+double schulz_analytical_2DXY(SchulzParameters *pars, double x, double y) {
+    return schulz_analytical_1D(pars, x) * schulz_analytical_1D(pars, y);
+}
+
+/**
+ * Function to evaluate 2D Schulz  function
+ * The function is normalized to the 'scale' parameter.
+ *
+ * f(x,y) = Schulz(x) * Schulz(y)
+ *
+ * where both Gaussians share the same parameters.
+ *
+ * @param pars: parameters of the gaussian
+ * @param length: length of the (x,y) vector
+ * @param phi: angle relative to x
+ * @return: function value
+ */
+double schulz_analytical_2D(SchulzParameters *pars, double length, double phi) {
+    return schulz_analytical_2DXY(pars, length*cos(phi), length*sin(phi));
+}
Index: sansmodels/src/sans/models/c_extensions/schulz.h
===================================================================
--- sansmodels/src/sans/models/c_extensions/schulz.h	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
+++ sansmodels/src/sans/models/c_extensions/schulz.h	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
@@ -0,0 +1,37 @@
+#if !defined(schulz_h)
+#define schulz_h
+
+/** Structure definition for Schulz parameters.
+ * The Schulz is normalized to the 'scale' parameter.
+ *  
+ * f(x)=scale * math.pow(z+1, z+1)*math.pow((R), z)*
+ *					math.exp(-R*(z+1))/(center*gamma(z+1)
+ *		z= math.pow[(1/(sigma/center),2]-1
+ *		R= x/center
+ * 
+ * [PYTHONCLASS] = Schulz
+ * [DESCRIPTION] = <text> f(x)=scale * math.pow(z+1, z+1)*math.pow((R), z)*
+ 					math.exp(-R*(z+1))/(center*gamma(z+1)
+ 		            z= math.pow[(1/(sigma/center),2]-1
+ 					R= x/center</text>
+ */
+typedef struct {
+    /// Scale factor 
+    //  [DEFAULT]=scale=1.0
+    double scale;
+    /// Standard deviation
+    //  [DEFAULT]=sigma=1 
+    double sigma;
+    /// Center of the Schulz distribution
+    //  [DEFAULT]=center=0.0 
+    double center;
+} SchulzParameters;
+
+/// 1D scattering function
+double schulz_analytical_1D(SchulzParameters *pars, double x);
+
+/// 2D scattering function
+double schulz_analytical_2D(SchulzParameters *pars, double x, double phi);
+double schulz_analytical_2DXY(SchulzParameters *pars, double x, double y);
+
+#endif
Index: sansmodels/src/sans/models/c_models/c_models.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/c_models.cpp	(revision 770bab1b907c20488df256707ca66e7bc3eccb32)
+++ sansmodels/src/sans/models/c_models/c_models.cpp	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
@@ -290,9 +290,9 @@
 	addCMultiShellModel(m);
 	addCBinaryHSModel(m);
-	//addDisperser(m);
-	//addCGaussian(m);
-	//addCSchulz(m);
-	//addCLogNormal(m);
-	//addCLorentzian(m);
+	addDisperser(m);
+	addCGaussian(m);
+	addCSchulz(m);
+	addCLogNormal(m);
+	addCLorentzian(m);
 	addCVesicleModel(m);
 	addCPoly_GaussCoil(m);
Index: sansmodels/src/sans/models/c_models/parameters.cpp
===================================================================
--- sansmodels/src/sans/models/c_models/parameters.cpp	(revision 8dc02d8b4348f58c310e83b1e0b10a5ab1e56f16)
+++ sansmodels/src/sans/models/c_models/parameters.cpp	(revision 59b9b67578f11772d51a4d61028e0dfc7097df5a)
@@ -58,11 +58,19 @@
 	Parameter* par = (Parameter*)param;
 	double value = (*par)();
-
-	if (npts<2) {
-		weights.insert(weights.end(), WeightPoint(value, 1.0));
-	} else {
-		for(int i=0; i<npts; i++) {
-			double val = value + width * (1.0*double(i)/double(npts-1) - 0.5);
-
+	double sig;
+	if (npts<2) {
+		weights.insert(weights.end(), WeightPoint(value, 1.0));
+	} else {
+		for(int i=0; i<npts; i++) {
+
+			if ((*par).has_min==false){
+				// width = sigma for angles
+				sig = width;
+			}
+			else{
+				//width = polydispersity (=sigma/value) for length
+				sig = width * value;
+			}
+			double val = value + sig * (1.0*double(i)/double(npts-1) - 0.5);
 			if ( ((*par).has_min==false || val>(*par).min)
 			  && ((*par).has_max==false || val<(*par).max)  )
@@ -83,7 +91,7 @@
 
 GaussianDispersion :: GaussianDispersion() {
-	npts  = 21;
+	npts  = 11;
 	width = 0.0;
-	nsigmas = 3.0;
+	nsigmas = 2.5;
 };
 
@@ -115,19 +123,27 @@
 		width = 0.0;
 		npts  = 1;
-		nsigmas = 3.0;
-	}
-
-	Parameter* par = (Parameter*)param;
-	double value = (*par)();
-
-	if (npts<2) {
-		weights.insert(weights.end(), WeightPoint(value, 1.0));
-	} else {
-		for(int i=0; i<npts; i++) {
+		nsigmas = 2.5;
+	}
+
+	Parameter* par = (Parameter*)param;
+	double value = (*par)();
+	double sig;
+	if (npts<2) {
+		weights.insert(weights.end(), WeightPoint(value, 1.0));
+	} else {
+		for(int i=0; i<npts; i++) {
+			if ((*par).has_min==false){
+				// width = sigma for angles
+				sig = width;
+			}
+			else{
+				//width = polydispersity (=sigma/value) for length
+				sig = width * value;
+			}
 			// We cover n(nsigmas) times sigmas on each side of the mean
-			double val = value + width * (2.0*nsigmas*double(i)/double(npts-1) - nsigmas);
+			double val = value + sig * (2.0*nsigmas*double(i)/double(npts-1) - nsigmas);
 			if ( ((*par).has_min==false || val>(*par).min)
 			  && ((*par).has_max==false || val<(*par).max)  ) {
-				double _w = gaussian_weight(value, width, val);
+				double _w = gaussian_weight(value, sig, val);
 				weights.insert(weights.end(), WeightPoint(val, _w));
 			}
@@ -142,5 +158,5 @@
 
 RectangleDispersion :: RectangleDispersion() {
-	npts  = 21;
+	npts  = 11;
 	width = 0.0;
 	nsigmas = 1.0;
@@ -182,14 +198,22 @@
 	Parameter* par = (Parameter*)param;
 	double value = (*par)();
-
-	if (npts<2) {
-		weights.insert(weights.end(), WeightPoint(value, 1.0));
-	} else {
-		for(int i=0; i<npts; i++) {
+	double sig;
+	if (npts<2) {
+		weights.insert(weights.end(), WeightPoint(value, 1.0));
+	} else {
+		for(int i=0; i<npts; i++) {
+			if ((*par).has_min==false){
+				// width = sigma for angles
+				sig = width;
+			}
+			else{
+				//width = polydispersity (=sigma/value) for length
+				sig = width * value;
+			}
 			// We cover n(nsigmas) times sigmas on each side of the mean
-			double val = value + width * (2.0*nsigmas*double(i)/double(npts-1) - nsigmas);
+			double val = value + sig * (2.0*nsigmas*double(i)/double(npts-1) - nsigmas);
 			if ( ((*par).has_min==false || val>(*par).min)
 			  && ((*par).has_max==false || val<(*par).max)  ) {
-				double _w = rectangle_weight(value, width, val);
+				double _w = rectangle_weight(value, sig, val);
 				weights.insert(weights.end(), WeightPoint(val, _w));
 			}
@@ -204,5 +228,5 @@
 
 LogNormalDispersion :: LogNormalDispersion() {
-	npts  = 21;
+	npts  = 11;
 	width = 0.0;
 	nsigmas = 3.0;
@@ -240,15 +264,23 @@
 	Parameter* par = (Parameter*)param;
 	double value = (*par)();
-
-	if (npts<2) {
-		weights.insert(weights.end(), WeightPoint(value, 1.0));
-	} else {
-		for(int i=0; i<npts; i++) {
+	double sig;
+	if (npts<2) {
+		weights.insert(weights.end(), WeightPoint(value, 1.0));
+	} else {
+		for(int i=0; i<npts; i++) {
+			if ((*par).has_min==false){
+				// width = sigma for angles
+				sig = width;
+			}
+			else{
+				//width = polydispersity (=sigma/value) for length
+				sig = width * value;
+			}
 			// We cover n(nsigmas) times sigmas on each side of the mean
-			double val = value + width * (2.0*nsigmas*double(i)/double(npts-1) - nsigmas);
+			double val = value + sig * (2.0*nsigmas*double(i)/double(npts-1) - nsigmas);
 
 			if ( ((*par).has_min==false || val>(*par).min)
 			  && ((*par).has_max==false || val<(*par).max)  ) {
-				double _w = lognormal_weight(value, width, val);
+				double _w = lognormal_weight(value, sig, val);
 				weights.insert(weights.end(), WeightPoint(val, _w));
 			}
@@ -264,5 +296,5 @@
 
 SchulzDispersion :: SchulzDispersion() {
-	npts  = 21;
+	npts  = 11;
 	width = 0.0;
 	nsigmas = 3.0;
@@ -303,15 +335,23 @@
 	Parameter* par = (Parameter*)param;
 	double value = (*par)();
-
-	if (npts<2) {
-		weights.insert(weights.end(), WeightPoint(value, 1.0));
-	} else {
-		for(int i=0; i<npts; i++) {
+	double sig;
+	if (npts<2) {
+		weights.insert(weights.end(), WeightPoint(value, 1.0));
+	} else {
+		for(int i=0; i<npts; i++) {
+			if ((*par).has_min==false){
+				// width = sigma for angles
+				sig = width;
+			}
+			else{
+				//width = polydispersity (=sigma/value) for length
+				sig = width * value;
+			}
 			// We cover n(nsigmas) times sigmas on each side of the mean
-			double val = value + width * (2.0*nsigmas*double(i)/double(npts-1) - nsigmas);
+			double val = value + sig * (2.0*nsigmas*double(i)/double(npts-1) - nsigmas);
 
 			if ( ((*par).has_min==false || val>(*par).min)
 			  && ((*par).has_max==false || val<(*par).max)  ) {
-				double _w = schulz_weight(value, width, val);
+				double _w = schulz_weight(value, sig, val);
 				weights.insert(weights.end(), WeightPoint(val, _w));
 			}
@@ -346,4 +386,5 @@
 		for(int i=0; i<npts; i++) {
 			double val = _values[i]; //+ value;  //ToDo: Talk to Paul and put back the 'value'.
+
 			if ( ((*par).has_min==false || val>(*par).min)
 			  && ((*par).has_max==false || val<(*par).max)  )
